/*******************************************************************************
*  skSDlib.c - llb^rcJ[hANZX֐Cu                        *
*                                                                              *
*    SD_Init     - llb^rcb̏s                            *
*    SD_Open     - t@C̃I[vs                                *
*    SD_Close    - t@C̃N[Ys                                *
*    SD_Write    - t@C֎w肵oCgޏ                  *
*    SD_Read     - t@Cw肵oCgǂݍޏ                *
*    SD_fGets    - t@CPsǂݍޏ                                *
*    SD_Size     - t@C̃TCY𓾂鏈                                  *
*    SD_Position - t@C̓Ǐ|C^l𓾂鏈                        *
*    SD_Seek     - t@C̓Ǐ|C^ړ鏈                    *
*                                                                              *
*    FWSDEMicroSD(FAT16)/WSDHCEMicroSDHC(FAT32)̂ݓǏnj     *
*          "skSDlib.h"SPICS(J[hIM)L̂Ńs̊tsB*
*                                                                              *
* ============================================================================ *
*  VERSION DATE        BY                    CHANGE/COMMENT                    *
* ---------------------------------------------------------------------------- *
*  1.00    2012-04-30  ޒH[(ނ)  Create                            *
*  2.00    2012-05-03  ޒH[(ނ)  SDHCɑΉ                        *
*  2.01    2012-06-09  ޒH[(ނ)  WSD/SDHCOKRgύX     *
*  2.02    2014-02-02  ޒH[(ނ)  XC8 C Compiler ΉɕύX         *
*  3.00    2014-09-01  bV񂩂̕  sC                        *
*  3.01    2014-09-03  ޒH[(ނ)  t@C8ssC   *
*  3.02    2014-09-03  ޒH[(ނ)  Seek()̃tO4̏ύX       *
*  4.00    2017-02-22  ޒH[(ނ)  XC16ƕI[vɑΉ      *
* ============================================================================ *
*  PIC 16F1938 18F2xK22 24EP256MC202                                           *
*  (Ԃ񂻂̑PICłSRAM768byteȏL΂̊֐͗p\Ǝv)      *
*  MPLAB X IDE v3.50                                                           *
*  MPLAB(R) XC8  C Compiler Version 1.32/1.40                                  *
*  MPLAB(R) XC16 C Compiler Version 1.30                                       *
*******************************************************************************/
#include <xc.h>
#include <string.h>
//#include "skMonitorLCD.h"
#include "skSPIlib.h"
#include "skSDlib.h"


char MMCbuffer[SECTER_BYTES] ;          // llbJ[hǏobt@
int  CardType ;                         // J[h̎
int  FatType ;                          // e`s̎

//e`st@CVXẽp[^
unsigned long Dir_Entry_StartP ;        // fBNgGg̊JnZN^ʒu
unsigned int  DirEntry_SectorSU ;       // fBNgGg̃ZN^
unsigned long Data_Area_StartP ;        // f[^̈̊JnZN^ʒu
unsigned long Fat_Area_StartP ;         // FAT̈̊JnZN^ʒu
unsigned int  Cluster1_SectorSU ;       // PNX^̃ZN^
unsigned long SectorsPerFatSU ;         // PgFAT̈悪߂ZN^


////////////////////////////////////////////////////////////////////////////////
// llb^rcb̃J[hIACSMHIGH/LOWo͂鏈
void cs_select(int flag)
{
     CS = flag ;
     SPI_transfer(0xff) ;     // mɂbrؑւׂɃNbN𑗐MĂ
}
////////////////////////////////////////////////////////////////////////////////
// fBԂ̃`FbNs
int ready_check()
{
     int c ;
     
     c = 0 ;
     while (SPI_transfer(0xff) != 0xff && c<=500) {
          c++ ;
          __delay_ms(1) ;
     }
     if (c>=500) return 1 ;    // ^CAEg
     else        return 0 ;    // njł
}
////////////////////////////////////////////////////////////////////////////////
// llb^rcbփR}h𑗂鏈
int send_command(unsigned char cmd, unsigned long arg)
{
     int x , ans ;

     cs_select(LOW) ;
     ans = ready_check() ;
     if (ans != 0) return 0xff00 ;           // J[h Busy 炵
     // R}h̑Ms
     SPI_transfer(cmd | 0x40) ;                             // R}h̑M
     for (x=24 ; x >= 0 ; x -= 8) SPI_transfer(arg >> x) ;  // p[^̑M
     x = 0XFF ;
     if (cmd == CMD0) x = 0X95 ;
     if (cmd == CMD8) x = 0X87 ;
     SPI_transfer(x) ;                                      // CRC̑M
     // R}h̕ԓ҂s
     x = 0 ;
     do {
          ans = SPI_transfer(0xff) ;
          x++;
     } while(ans & 0x80 && x < 256) ;
    if (x >= 256) ans = (cmd|0x40) << 8 ;    // X|X^CAEg

    return ans ;
}
////////////////////////////////////////////////////////////////////////////////
// w̃ZN^ʒuf[^PubN(VOECg)ޏ
int sblock_write(unsigned long sector,char *buff)
{
     int i , ans ;

     if (CardType != 0x13) sector <<= 9 ;         // SDHCłȂ
     ans = send_command(CMD24, sector) ;          // VOE[hR}h̔s
     if (ans == 0) {
          SPI_transfer(0xfe) ;                    // f[^g[N̑M
          for (i=0 ; i<SECTER_BYTES ; i++) {
               SPI_transfer(*buff) ;              // f[^̑M
               buff++ ;
          }
          SPI_transfer(0xff) ;                    // CRC̕𑗐M
          SPI_transfer(0xff) ;
          ans = SPI_transfer(0xff) ;              // X|X̎M
          ans = ans & 0x1F ;
		if (ans == 0x05) {
               ans = ready_check() ;
               if (ans != 0) ans = 0x8800 ;       // J[h Busy 炵
               else {
                    // ݂ɍsꂽ₢킹s
                    ans = send_command(CMD13, sector) ;
                    i  = SPI_transfer(0xff) ;
                    if (ans == 0) {
                         if (i != 0) ans = 0x8900|ans ; // ݎsĂ
                    }
               }
          } else ans = 0x8800 | ans ;             // ݃G[
     } else ans = CMD24 << 8 | ans ;              // CMD24G[
     cs_select(HIGH) ;

     return ans ;
}
////////////////////////////////////////////////////////////////////////////////
// w̃ZN^ʒuf[^PubN(VOE[h)Ǎޏ
int sblock_read(unsigned long sector,char *buff)
{
     int i , ans ;

     if (CardType != 0x13) sector <<= 9 ;         // SDHCłȂ
     ans = send_command(CMD17, sector) ;          // VOE[hR}h̔s
     if (ans == 0) {
          i = 0 ;
          // ԐMf[^̂PoCgڂ҂
          while(1) {
               ans = SPI_transfer(0xff) ;
               i++ ;
               if (ans != 0xff || i>=1000) {
                    if (i>=1000) ans = 0x8600 ;   // f[^g[N^CAEg
                    break ;
               }
               __delay_ms(1) ;
          }
          // QoCgڈȍ~̎M
          if (ans == 0xfe) {
               for (i=0 ; i<SECTER_BYTES ; i++) {
                    *buff = SPI_transfer(0xff) ;
                     buff++ ;
               }
               SPI_transfer(0xff) ;               // CRC̕M
               SPI_transfer(0xff) ;
               ans = 0 ;
          } else ans = 0x8600 | ans ;             // ǂݍ݃G[
     } else ans = CMD17 << 8 | ans ;              // CMD17G[
     cs_select(HIGH) ;

     return ans ;
}
////////////////////////////////////////////////////////////////////////////////
// e`st@CVXẽp[^Ǎޏ
int fat_para_read()
{
     union {
          unsigned char c[4] ;
          unsigned long l ;
     } dt ;
     struct FAT_PARA *fat ;
     int i , ans ;

     // J[h̐擪TPQoCgǂݏo
     ans = sblock_read(0,MMCbuffer) ;
     if (ans == 0) {
          // BPB(u[gZN^)܂ł̃ItZbglo
          for (i=0 ; i<4 ; i++) {
               dt.c[i] = MMCbuffer[i+0x1c6] ;
          }
          // e`st@CVXẽp[^Ǎ
          ans = sblock_read(dt.l,MMCbuffer) ;
          if (ans == 0) {
               fat = (struct FAT_PARA *)MMCbuffer ;
               // PNX^̃ZN^
               Cluster1_SectorSU = fat->SectorsPerCluster ;
               // PgFAT̈悪߂ZN^
               if (fat->SectorsPerFat16 != 0) {
                    FatType = 2 ;
                    SectorsPerFatSU = fat->SectorsPerFat16 ;
               } else {
                    FatType = 4 ;
                    SectorsPerFatSU = fat->SectorsPerFat32 ;
               }
               // e`s̈̊JnZN^ʒu
               Fat_Area_StartP = fat->ReservedSectorCount + dt.l ;
               // [gfBNgGg̊JnZN^ʒu
               Dir_Entry_StartP = Fat_Area_StartP + (SectorsPerFatSU * fat->FatCount) ;
               // f[^̈̊JnZN^ʒu
               DirEntry_SectorSU = fat->RootDirEntryCount / (SECTER_BYTES / sizeof(struct DIR_ENTRY)) ;
               Data_Area_StartP  = Dir_Entry_StartP + DirEntry_SectorSU ;
               if (FatType == 4) DirEntry_SectorSU = Cluster1_SectorSU ;   // FAT32
          }
     }
     return ans ;
}
/*******************************************************************************
*  ans = SD_Init()                                                             *
*    llb^rcb̏s                                          *
*    W^CvSD/SDHCMicroSD/SDHCFAT16/FAT32̂ݗp\                  *
*                                                                              *
*    ans  : 큁O  ُ큁OȊÕG[R[hl                             *
*******************************************************************************/
int SD_Init()
{
     unsigned long arg ;
     unsigned char r7[4] ;
     unsigned int i , ans ;

     CS       = 1 ;
     CardType = 0 ;

     // CLK74NbNȏ㑗MAJ[hR}h҂Ԃɂ
     for (i = 0 ; i < 10 ; i++) SPI_transfer(0xFF) ;

     // J[hɃZbgR}h(CMD0)𑗐M(SPI[hɈڍs)
     ans = send_command(CMD0, 0) ;
     if (ans == 1) {
//          MonitorPuts("CMD0") ;
          // rcbp̏s
          arg = 0 ;
          // d̊mFƃJ[h̃o[W`FbN
          ans = send_command(CMD8, 0x1AA) ;
          if (ans == 1) {
               for (i=0 ; i<4 ; i++) r7[i] = SPI_transfer(0xff) ;
               if (r7[3] == 0xAA) {
                    CardType = 0x12 ;                  // SDCver.2̃J[h
                    arg = 0X40000000 ;
               } else ans = 0x8200 ;                   // CMD8̃G[
          } else {
               if (ans & 0x4) CardType = 0x11 ;        // SDCver.1̃J[h
          }
          if (CardType != 0) {
//               MonitorPuts(":8") ;
               // rcbp̏R}h(ACMD41)𔭍s
               i = 0 ;
               while(1) {
                    ans = send_command(CMD55, 0) ;
                    ans = send_command(ACMD41, arg) ;
                    i++ ;
                    if (ans == 0 || i>=2000) {
                         if (i>=2000) ans = 0x8300|ans ;    // ACMD41^CAEg
                         break ;
                    }
                    __delay_ms(1) ;
               }
//               if (ans == 0) MonitorPuts(":A41") ;
               if (ans == 0 && CardType == 0x12) {
                    // Ver.2ȂOCR̓ǏoR}h(CMD58)𔭍s
                    ans = send_command(CMD58, 0) ;
                    if (ans == 0) {
//                         MonitorPuts(":58") ;
                         for (i=0 ; i<4 ; i++) r7[i] = SPI_transfer(0xff) ;
                         if (r7[0] & 0x40) CardType = 0x13 ;// SDHC̃J[h
                    } else ans = CMD58 << 8 | ans ;         // CMD58G[
               }
          } else {
               // llbp̏R}h(CMD1)𔭍s
               i = 0 ;
               while(1) {
                    ans = send_command(CMD1, 0) ;
                    i++ ;
                    if (ans != 1 || i>=2000) {
                         if (i>=2000) ans = 0x8100 ;   // ^CAEg
                         break ;
                    }
                    __delay_ms(1) ;
               }
               if (ans == 0) {
                    CardType = 0x01 ;                  // MMC̃J[h
//                    MonitorPuts(":1") ;
               } else {
                    if (ans != 0x8100) ans = CMD1 << 8 | ans ;   // CMD1G[
               }
          }
          if (ans == 0) {
               // ubNTCY̏lTPQoCgɍĐݒ肷
               ans = send_command(CMD16, SECTER_BYTES) ;
               if (ans != 0) ans = CMD16 << 8 | ans ;  // CMD16̃G[
//               else MonitorPuts(":16") ;
          }
     } else ans = CMD0 << 8 | ans ;                    // CMD0G[
     cs_select(HIGH) ;
     
     // ɏIe`st@CVXẽp[^Ǎ
     if (ans == 0) {
          ans = fat_para_read() ;
     }

//          MonitorPuts("CardType = ") ;
//          MonitorPuth(CardType,HEX) ;

     return ans ;
}
////////////////////////////////////////////////////////////////////////////////
// wt@C̃Gg𓾂AȂ΃Gg̋̏ꏊ𓾂鏈
int search_file(char *filename,struct SDFILE_OBJECT *fp)
{
     struct DIR_ENTRY *inf ;
     int i , j , c , x , ans ;

     ans = c = 0 ;
     fp->DirEntryIndex = 0 ;
     // fBNgGg̑SZN^JԂ
     for (i=0 ; i<DirEntry_SectorSU ; i++) {
          // fBNgGg̃f[^Ǎ
          ans = sblock_read(Dir_Entry_StartP+i,MMCbuffer) ;
          if (ans == 0) {
               // PZN^̃GǧJԂ
               x = SECTER_BYTES / sizeof(struct DIR_ENTRY) ;
               for (j=0 ; j<x ; j++ ) {
                    c++ ;
                    // t@C̃Gg𒲂ׂ
                    inf = (struct DIR_ENTRY *)&MMCbuffer[j*sizeof(struct DIR_ENTRY)] ;
                    if (inf->FileName[0] == 0x2e) continue ;// TufBNg
                    if (inf->FileName[0] == 0xe5) {
                         if (fp->DirEntryIndex == 0) fp->DirEntryIndex = c ;
                         continue ;                         // 폜ꂽGg
                    }
                    if (inf->FileName[0] == 0x00) {
                         if (fp->DirEntryIndex == 0) fp->DirEntryIndex = c ;
                         i = DirEntry_SectorSU ;
                         ans = 2 ;                          // Ȃ
                         break ;                            // ̃Gg
                    }
                    // t@C̑𒲂ׂ
                    // 0x000x20łȂȂ畁ʂ̃t@CłȂƂ
                    if (!((inf->Attributes==0x20)||(inf->Attributes==0x00))) continue ;
                    // t@Cr
                    if (memcmp(inf->FileName,filename,11) == 0) {
                         fp->DirEntryIndex = c ;
                         // t@C̃ANZXݒ肷
                         fp->FileSeekP = 0 ;               // t@C̓Ǎވʒu͂O
                         fp->FileSize = inf->FileSize ;    // t@C̃TCY
                         // f[^i[FATԍL^
                         fp->FirstFatno = inf->FirstClusterHigh ;
                         fp->FirstFatno = (fp->FirstFatno<<16) | inf->FirstClusterLow ;
                         i = DirEntry_SectorSU ;
                         ans = 1 ;
                         break ;                            // I
                    }
               }
          } else ans = -1 ;
     }

     return ans ;
}
////////////////////////////////////////////////////////////////////////////////
// 󂫂̂e`sԍT
unsigned long search_fat()
{
     unsigned long ans ;
     unsigned int i ;
     int j , x , k ;

     ans = 0 ;
     // Pg̑e`sJԂ
     for (i=0 ; i<SectorsPerFatSU ; i++) {
          if (sblock_read(Fat_Area_StartP+i,MMCbuffer) == 0) {
               for (j=0 ; j<SECTER_BYTES ; j=j+FatType) {
                    // 󂫂̂e`sL
                    x = 0 ;
                    for (k=0 ; k<FatType ; k++) x = x | MMCbuffer[j+k] ;
                    if (x == 0) {
                         MMCbuffer[j]   = 0xff ;
                         MMCbuffer[j+1] = 0xff ;
                         if (FatType == 4) {    // FAT32
                              MMCbuffer[j+2] = 0xff ;
                              MMCbuffer[j+3] = 0x0f ;
                         }
                         // \XV
                         if (sblock_write(Fat_Area_StartP+i,MMCbuffer) == 0) {
                              // QgڂFAT
                              sblock_write((Fat_Area_StartP+i)+SectorsPerFatSU,MMCbuffer) ;
                              ans = (i * SECTER_BYTES + j) / FatType ;
                         }
                         i = SectorsPerFatSU ;
                         break ;  // I
                    }
               }
          } else break ;
     }
     return ans ;
}
////////////////////////////////////////////////////////////////////////////////
// fBNgGg̍XV
int direntry_make(unsigned long no,char *filename,struct SDFILE_OBJECT *fp)
{
     struct DIR_ENTRY *inf ;
     unsigned long p ;
     unsigned int x , y ;
     int ans ;

     ans = -1 ;
     // fBNgGgǍ
     x = fp->DirEntryIndex - 1 ;
     y = SECTER_BYTES / sizeof(struct DIR_ENTRY) ;
     p = Dir_Entry_StartP + (x / y) ;
     if (sblock_read(p,MMCbuffer) == 0) {
          inf = (struct DIR_ENTRY *)&MMCbuffer[(x % y) * sizeof(struct DIR_ENTRY)] ;
          if (no != 0) {
               memset(inf,0x00,sizeof(struct DIR_ENTRY)) ;
               // t@Cݒ肷
               memcpy(inf->FileName,filename,11) ;
               // t@C̑ݒ肷
               inf->Attributes = 0x20 ;
               // t@C̐VK쐬
               inf->FileSize = 0 ;
               // t@C̍쐬Ԃݒ肷
               inf->CreationTimeTenths = 0 ;
               inf->CreationTime       = 0 ;
               inf->LastWriteTime      = 0 ;
               // t@C̍쐬ݒ肷
               inf->CreationDate  = 0 ;
               inf->LastWriteDate = 0 ;
               // ANZXݒ肷
               inf->LastAccessDate = 0 ;
               // f[^i[FATԍݒ肷
               inf->FirstClusterHigh = (unsigned int)(no >> 16) ;
               inf->FirstClusterLow  = (unsigned int)(no & 0x0000ffff) ;
               // t@C̃ANZXݒ肷
               fp->FileSeekP = 0 ;
               fp->FileSize  = 0 ;
               // f[^i[FATԍL^
               fp->FirstFatno = inf->FirstClusterHigh ;
               fp->FirstFatno = (fp->FirstFatno<<16) | inf->FirstClusterLow ;
          } else {
               // t@C̃TCYXV
               inf->FileSize = inf->FileSize + fp->AppendSize ;
               // t@Cݓݒ肷
               
               // ANZXݒ肷
               
          }
          // fBNgGg̍XV
          ans = sblock_write(p,MMCbuffer) ;
     }
     return ans ;
}
////////////////////////////////////////////////////////////////////////////////
// t@C̐`s
void filename_check(char *c,const char *filename)
{
     int i ;

     memset(c,0x20,11) ;
     for (i=0 ; i<8 ; i++) {
          if (*filename == '.') {
               c = c + (8-i) ;
               filename++ ;
               break ;
          }
          *c = *filename ;
          c++ ;
          filename++ ;
     }
     if (i > 7) filename++ ;
     for (i=0 ; i<3 ; i++) {
          if (*filename == 0x00) break ;
          *c = *filename ;
          c++ ;
          filename++ ;
     }
}
/*******************************************************************************
*  ans = SD_Open(fp,filename,oflag)                                            *
*    t@C̃I[vs                                              *
*    *fp      : SDFILE_OBJECT^\̂ւ̃|C^[w肵܂                *
*    *filename: t@C(xxxxxxxx.xxx)w肵܂                           *
*               gq͕KwA܂p͑啶w B                  *
*    oflag    : ANZX̃tOw肵܂                                   *
*               O_READ   ǂݍݐp(t@C݂Ȃ̓G[)          *
*               O_APPEND ǉݐp(t@C̍Ōɒǉ܂)            *
*               O_RDWR   ǂݏ\(t@C͍쐬܂)          *
*                                                                              *
*    ans  : 큁O  ُ큁|P                                               *
*******************************************************************************/
int SD_Open(struct SDFILE_OBJECT *fp,const char *filename,int oflag)
{
     unsigned long no ;
     char c[11] ;
     int  ans , ret ;

     ret = -1 ;
//     if (fp->Oflag != 0) return ret ;        // ɃI[vĂ
     fp->Oflag = 0 ;
     // w̃t@C𐬌`
     filename_check(c,filename) ;
     // w肳ꂽt@C
     ans = search_file(c,(struct SDFILE_OBJECT *)fp) ;
     if (ans > 0) {
          if (oflag == O_READ && ans == 1) ret = 0 ;
          if (oflag == O_APPEND && ans == 1) {
               // t@C̃ANZXʒut@C̍Ō{Pɐݒ肷
               fp->FileSeekP = fp->FileSize ;
               ret = 0 ;
          }
          if (oflag == O_RDWR && (ans == 1 || ans == 2)) {
               if (ans == 2) {
                    // VKt@C̍쐬s
                    if (fp->DirEntryIndex != 0) {
                         // 󂫂FATTĊmۂ
                         no = search_fat() ;
                         if (no != 0) {
                              // fBNgGg̍쐬s
                              if (direntry_make(no,c,(struct SDFILE_OBJECT *)fp) == 0) ret = 0 ;
                         }
                    }
               } else ret = 0 ;
          }
          if (ret == 0) {
               // t@CɃANZX\Ƃ
               fp->Oflag = oflag ;
               fp->AppendSize = 0 ;
          }
     }

     return ret ;
}
/*******************************************************************************
*  SD_Close(fp)                                                                *
*    t@C̃N[Ys                                              *
*    f[^ǉ̃t@CTCY̊֐ŏ܂܂B            *
*    *fp : SDFILE_OBJECT^\̂ւ̃|C^[w肵܂                     *
*******************************************************************************/
void SD_Close(struct SDFILE_OBJECT *fp)
{
     // ݃I[v̏
     if (fp->Oflag & (O_APPEND | O_RDWR)) {
          if (fp->AppendSize == 0) return ;
          // fBNgGg̍XVs
          direntry_make(0,0,(struct SDFILE_OBJECT *)fp) ;
     }
     // t@C̃ANZX
     fp->Oflag = 0 ;
}
////////////////////////////////////////////////////////////////////////////////
// w肳ꂽFATԍ̎FATԍ𓾂鏈
unsigned long next_fat_read(unsigned long fatno,struct SDFILE_OBJECT *fp)
{
     union {
          unsigned char c[4] ;
          unsigned long i ;
     } no ;
     unsigned long p , x , y , ans ;
     int j ;

     // e`s̈̃f[^Ǎ
     p = Fat_Area_StartP + (fatno / (SECTER_BYTES/FatType)) ;
     ans = sblock_read(p,MMCbuffer) ;
     if (ans == 0) {
          x = (fatno % (SECTER_BYTES/FatType)) * FatType ;
          no.i = 0 ;
          for (j=0 ; j<FatType ; j++) no.c[j] = MMCbuffer[x+j] ;
          // ̃`F[FATԍ𓾂
          ans = no.i ;
          if (FatType == 4) y = 0x0fffffff ;  // FAT32
          else              y = 0xffff ;
          // ̃`F[悪Ȃ͐VKɃ`F[e`s쐬
          if (y == ans) {
               ans = search_fat() ;     // Ve`sԍ̋󂫂T
               if (ans != 0) {
                    // `F[̂e`sXV
                    if (sblock_read(p,MMCbuffer) == 0) {
                         no.i = ans ;
                         for (j=0 ; j<FatType ; j++) MMCbuffer[x+j] = no.c[j] ;
                         if (sblock_write(p,MMCbuffer) == 0) {
                              // QgڂFAT
                              sblock_write(p + SectorsPerFatSU,MMCbuffer) ;
                         } else ans = 0 ;
                    } else ans = 0 ;
               }
          }
     } else ans = 0 ;

     return ans ;
}
////////////////////////////////////////////////////////////////////////////////
// V[NʒuFATԍ(NX^ԍ)Zo鏈
void fatno_seek_conv(unsigned long *fatno,struct SDFILE_OBJECT *fp)
{
     unsigned int  p ;
     int  i ;

     // f[^̃V[NʒuǏo_ZN^ʒuZoԖڂ̘_NX^ʒuH
     p = (fp->FileSeekP / SECTER_BYTES) / Cluster1_SectorSU ;
     // FAT̈_NX^ۂFATԍ(NX^ԍ)Zo
     *fatno = fp->FirstFatno ;
     for (i=0 ; i<p ; i++) {
          // ̃`F[FATԍǍł
          *fatno = next_fat_read(*fatno,(struct SDFILE_OBJECT *)fp) ;
     }
}
////////////////////////////////////////////////////////////////////////////////
// ̊֐ۂɃt@Cw肵oCgǂݍޏ
// type : 1=SD_Read̃R[  2=SD_fGets̃R[  3=SD_WritẽR[
int sd_rdwr(char *buf,int nbyte,int type,struct SDFILE_OBJECT *fp)
{
     unsigned long dtSP ;
     unsigned long fatno ;
     unsigned int  p , x ;
     int  i , c , ans ;

     // V[NʒuFATԍ(NX^ԍ)Zo
     fatno_seek_conv(&fatno,(struct SDFILE_OBJECT *)fp) ;
     if (fatno == 0) return -1 ;                       // FAT̈Ǎ݃G[
     // f[^̐擪ZN^ʒu̎Zo
     dtSP = Data_Area_StartP + ((fatno - 2) * Cluster1_SectorSU) ;
     p = (fp->FileSeekP / SECTER_BYTES) % Cluster1_SectorSU ; // NX^̃ZN^ʒu
     // f[^̈悩t@CeǏo
     ans = sblock_read(dtSP+p,MMCbuffer) ;
     if (ans == 0) {
          x = fp->FileSeekP % SECTER_BYTES ;
          c = 0 ;
          // woCgԂJԂ
          for (i=0 ; i<nbyte ; i++ ) {
               if (type == 3) MMCbuffer[x] = *buf ;    // 
               else           *buf = MMCbuffer[x] ;    // Ǎ
               c++ ;
               x++ ;
               fp->FileSeekP++ ;
               if (fp->FileSeekP >= fp->FileSize) {
                    if (type < 3) break ;              // Ō܂œǂݍ
                    fp->AppendSize++ ;                 // f[^ǉꂽJEg
               }
               if (c >= SECTER_BYTES) break ;          // SECTER_BYTES
               if (type == 2 && *buf == 0x0a) break ;  // keȂI
               // ̃ZN^Ƀf[^܂ꍇ̏
               if (x >= SECTER_BYTES) {
                    // ݗvȂ炱܂ł̃f[^
                    if (type == 3) {
                         ans = sblock_write(dtSP+p,MMCbuffer) ;
                         if (ans != 0) {
                              ans = -1 ;               // f[^̈揑݃G[
                              break ;
                         }
                    }
                    p++ ;
                    if (p >= Cluster1_SectorSU) {
                         // ̃NX^Ƀf[^L悤ł
                         // V[Nʒu玟FATԍ(NX^ԍ)Zo
                         fatno_seek_conv(&fatno,(struct SDFILE_OBJECT *)fp) ;
                         if (fatno == 0) {
                              ans = -1 ;               // FAT̈Ǎ݃G[
                              break ;
                         }
                         // f[^̐擪ZN^ʒu̎Zo
                         dtSP = Data_Area_StartP + ((fatno - 2) * Cluster1_SectorSU) ;
                         p = (fp->FileSeekP / SECTER_BYTES) % Cluster1_SectorSU ; // NX^̃ZN^ʒu
                    }
                    // ̃ubNǍ
                    ans = sblock_read(dtSP+p,MMCbuffer) ;
                    if (ans == 0) x = 0 ;
                    else {
                         ans = -1 ;                    // f[^̈Ǎ݃G[
                         break ;
                    }
               }
               buf++ ;
          }
          // ݗvȂf[^
          if (x != 0 && ans != -1 && type == 3) {
               ans = sblock_write(dtSP+p,MMCbuffer) ;
               if (ans != 0) ans = -1 ;                // f[^̈揑݃G[
          }
          if (ans != -1) ans = c ;                     // Ǐ񂾃oCgԂ
     } else ans = -1 ;                                 // f[^̈Ǎ݃G[

     return ans ;
}
/*******************************************************************************
*  ans = SD_Write(fp,buf,nbyte)                                                *
*    t@C֎w肵oCgޏ                                *
*    t@C̐擪珑܂܂AވʒuςꍇSD_Seekgp     *
*    *fp   : SDFILE_OBJECT^\̂ւ̃|C^[w肵܂                   *
*    *buf  : ރf[^i[zϐw肵܂                        *
*    nbyte : ރf[^̃oCgw肵܂                                *
*                                                                              *
*    ans  : 큁񂾃oCg  ُ큁|P                                 *
*******************************************************************************/
int SD_Write(struct SDFILE_OBJECT *fp,const char *buf,int nbyte)
{
     char *p ;
     
     p = (char *)buf ;
     if (!(fp->Oflag & (O_APPEND | O_RDWR))) return -1 ; // ݃I[vłȂG[
     return sd_rdwr(p,nbyte,3,(struct SDFILE_OBJECT *)fp) ;
}
/*******************************************************************************
*  ans = SD_Read(fp,buf,nbyte)                                                 *
*    t@Cw肵oCgǂݍޏ                              *
*    t@C̐擪Ǎ܂܂AǍވʒuςꍇSD_Seekgp     *
*    *fp   : SDFILE_OBJECT^\̂ւ̃|C^[w肵܂                   *
*    *buf  : Ǎ񂾃f[^i[zϐw肵܂                      *
*    nbyte : Ǎރf[^̃oCgw肵܂                                *
*            t@C̍Ō(EOF)̏ꍇAnbyteɖȂĂŒ~܂    *
*                                                                              *
*    ans  : 큁Ǎ񂾃oCg  ُ큁|P  dneO                     *
*******************************************************************************/
int SD_Read(struct SDFILE_OBJECT *fp,char *buf,int nbyte)
{
     if (!(fp->Oflag & (O_READ | O_RDWR))) return -1 ; // Ǎ݃I[vłȂG[
     if (fp->FileSeekP >= fp->FileSize)    return  0 ; // EOF
     return sd_rdwr(buf,nbyte,1,(struct SDFILE_OBJECT *)fp) ;
}
/*******************************************************************************
*  ans = SD_fGets(fp,buf,nbyte)                                                *
*    t@CPsǂݍޏ                                              *
*    0x0A(LF)ɏo܂œǍ݂܂A 0x0d(CR)0x0a(LF) OKłB        *
*    CRLF̓f[^Ƃbufɓ܂Abuf̊mۂf[^TCYɒӂłB  *
*    ܂ALFɏoȂnbyte܂œǍ݂܂B                             *
*    *fp   : SDFILE_OBJECT^\̂ւ̃|C^[w肵܂                   *
*    *buf  : Ǎރf[^i[zϐw肵܂                        *
*    nbyte : Ǎރf[^̃oCgw肵܂                                *
*                                                                              *
*    ans  : 큁Ǎ񂾃oCg  ُ큁|P  dneO                     *
*******************************************************************************/
int SD_fGets(struct SDFILE_OBJECT *fp,char *buf,int nbyte)
{
     if (!(fp->Oflag & (O_READ | O_RDWR))) return -1 ; // Ǎ݃I[vłȂG[
     if (fp->FileSeekP >= fp->FileSize)    return  0 ; // EOF
     return sd_rdwr(buf,nbyte,2,(struct SDFILE_OBJECT *)fp) ;
}
/*******************************************************************************
*  ans = SD_Size(fp)                                                           *
*    t@C̃TCY𓾂鏈(SDɏ܂ĂTCYԂ)            *
*    *fp  : SDFILE_OBJECT^\̂ւ̃|C^[w肵܂                    *
*                                                                              *
*    ans  : 큁t@C̃TCY  ُ큁0xffffffff                           *
*******************************************************************************/
unsigned long SD_Size(struct SDFILE_OBJECT *fp)
{
     if (fp->Oflag == 0) return 0xffffffff ;
     return fp->FileSize + fp->AppendSize ;
}
/*******************************************************************************
*  ans = SD_Position(fp)                                                       *
*    t@C̓Ǐ|C^l𓾂鏈                                      *
*    *fp  : SDFILE_OBJECT^\̂ւ̃|C^[w肵܂                    *
*                                                                              *
*    ans  : 큁݈ʒutĂt@C|C^l  ُ큁0xffffffff   *
*******************************************************************************/
unsigned long SD_Position(struct SDFILE_OBJECT *fp)
{
     if (fp->Oflag == 0) return 0xffffffff ;
     return fp->FileSeekP ;
}
/*******************************************************************************
*  ans = SD_Seek(fp,offset,sflag)                                              *
*    t@C̓Ǐ|C^ړ鏈                                  *
*    *fp    : SDFILE_OBJECT^\̂ւ̃|C^[w肵܂                  *
*    offset : ʒutꏊ(ItZbgl)w肵܂                       *
*    sflag  : ʒutItZbgl̕tOw肵܂           *
*             1 = t@C̐擪̃ItZbglł                       *
*             2 = ݂̏ꏊɈʒutItZbglł         *
*             3 = ݂̏ꏊOɈʒutItZbglł           *
*             4 = t@CŌ̃oCgɈʒut܂             *
*                                                                              *
*    ans  : 큁ړ̃t@C|C^l  ُ큁0xffffffff                 *
*******************************************************************************/
unsigned long SD_Seek(struct SDFILE_OBJECT *fp,unsigned long offset,int sflag)
{
     unsigned long x , ans ;

     ans = 0xffffffff ;
     if (!(fp->Oflag & (O_READ | O_RDWR))) return ans ; // READ/RDWRI[vȊO̓G[
     if (fp->AppendSize != 0) return ans ;              // f[^ǉ̓V[NoȂ
     switch (sflag) {
        case 1:// 擪ʒut
               if (offset < fp->FileSize) ans = fp->FileSeekP = offset ;
               break ;
        case 2:// ݂̏ꏊɈʒut
               x = fp->FileSeekP + offset ;
               if (x < fp->FileSize) ans = fp->FileSeekP = x ;
               break ;
        case 3:// ݂̏ꏊOɈʒut
               x = fp->FileSize - fp->FileSeekP ;
               if (x >= offset) ans = fp->FileSeekP = fp->FileSeekP - offset ;
               break ;
        case 4:// t@C̍Ō̃oCgɈʒut܂
               if (fp->FileSize != 0) ans = fp->FileSeekP = (fp->FileSize-1) + offset ;
               else                   ans = fp->FileSeekP = 0 ;
               break ;
     }
     return ans ;
}
