/*******************************************************************************
*  skSPIlib.h - rohʐMs֐̃wb_t@C                           *
*               (PIC 12F1822 16F182x 16F193x 18F2xK22)                         *
*                                                                              *
* ============================================================================ *
*  VERSION DATE        BY                    CHANGE/COMMENT                    *
* ---------------------------------------------------------------------------- *
*  1.00    2012-04-30  ޒH[            Create                            *
*  1.11    2014-06-21  ޒH[(ނ)  SPI_MODẼRgύX          *
*  2.00    2014-09-03  ޒH[(ނ)  18F25K22̓mF,ݏ~߂*
*  3.00    2015-04-05  ޒH[(ނ)  x/]mode֐ǉ           *
*  3.10    2015-04-20  ޒH[(ނ)  SSP1/SSP216F193xɑΉ      *
*  3.20    2016-06-14  ޒH[(ނ)  SPI_MODECKE(NbNʑ)ύX *
*******************************************************************************/
#ifndef _SKSPILIB_H_
#define _SKSPILIB_H_


// 萔̒`
#ifndef LOW
#define LOW  0
#endif
#ifndef HIGH
#define HIGH 1
#endif

#define SPI_MODE1 1           // NbNɐ(0:LOW)  NbNʑ(0:ACh0VŁA0V->5Vɕωœ])
#define SPI_MODE0 0           // NbNɐ(0:LOW)  NbNʑ(1:ACh0VŁA5V->0Vɕωœ])
#define SPI_MODE3 3           // NbNɐ(1:HIGH) NbNʑ(0:ACh5VŁA5V->0Vɕωœ])
#define SPI_MODE2 2           // NbNɐ(1:HIGH) NbNʑ(1:ACh5VŁA0V->5Vɕωœ])
#define SPI_CLOCK_DIV4   0x0  // ʐMx  Fosc/4
#define SPI_CLOCK_DIV16  0x1  // ʐMx  Fosc/16
#define SPI_CLOCK_DIV64  0x2  // ʐMx  Fosc/64
#define SPI_CLOCK_DIVT2  0x3  // ʐMx  TMR2̏o͂1/2
#define SPI_CLOCK_DIVADD 0xA  // ʐMx  FOSC/((SSPxADD + 1)*4)

//#define SPI_MSSP2_USE         // MSSP2𗘗pꍇ̓RgO܂B
// lrroW[̃WX^[`
#if defined(_16F1933)||defined(_16F1934)||defined(_16F1936)||\
    defined(_16F1937)||defined(_16F1938)||defined(_16F1939)
// 16F193xpMSSP𗘗pꍇ̒`
#define SPI_SSPCON1         SSPCON1
#define SPI_SSPSTAT         SSPSTAT
#define SPI_SSPADD          SSPADD
#define SPI_SSPBUF          SSPBUF
#define SPI_SSPIF           SSPIF
#else
#ifdef  SPI_MSSP2_USE
// MSSP2𗘗pꍇ̒`
#define SPI_SSPCON1         SSP2CON1
#define SPI_SSPSTAT         SSP2STAT
#define SPI_SSPADD          SSP2ADD
#define SPI_SSPBUF          SSP2BUF
#define SPI_SSPIF           SSP2IF
#else
// MSSP1𗘗pꍇ̒`
#define SPI_SSPCON1         SSP1CON1
#define SPI_SSPSTAT         SSP1STAT
#define SPI_SSPADD          SSP1ADD
#define SPI_SSPBUF          SSP1BUF
#define SPI_SSPIF           SSP1IF
#endif
#endif

// ֐̃vg^Cv錾
void SPI_Init(char mode,char divider,int sdo) ;
void SPI_setDataMode(char mode) ;
void SPI_setClockDivider(char divider,char rate) ;
unsigned char SPI_transfer(char dt) ;


#endif
